"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

import requests as requests_http
from . import utils
from typing import Optional
from vesselapi.models import operations

class Calls:
    _client: requests_http.Session
    _security_client: requests_http.Session
    _server_url: str
    _language: str
    _sdk_version: str
    _gen_version: str

    def __init__(self, client: requests_http.Session, security_client: requests_http.Session, server_url: str, language: str, sdk_version: str, gen_version: str) -> None:
        self._client = client
        self._security_client = security_client
        self._server_url = server_url
        self._language = language
        self._sdk_version = sdk_version
        self._gen_version = gen_version
        
    
    def batch(self, request: operations.GetBatchCrmCallRequestBody) -> operations.GetBatchCrmCallResponse:
        r"""Batch Calls
        Retrieve Call by a set of Id's
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/call/batch'
        headers = {}
        req_content_type, data, form = utils.serialize_request_body(request, "request", 'json')
        if req_content_type not in ('multipart/form-data', 'multipart/mixed'):
            headers['content-type'] = req_content_type
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('POST', url, data=data, files=form, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.GetBatchCrmCallResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.GetBatchCrmCallResponseBody])
                res.response_body = out

        return res

    
    def create(self, request: operations.PostCrmCallRequestBody) -> operations.PostCrmCallResponse:
        r"""Create Call
        Create a new Call.
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/call'
        headers = {}
        req_content_type, data, form = utils.serialize_request_body(request, "request", 'json')
        if req_content_type not in ('multipart/form-data', 'multipart/mixed'):
            headers['content-type'] = req_content_type
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('POST', url, data=data, files=form, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.PostCrmCallResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.PostCrmCallResponseBody])
                res.response_body = out

        return res

    
    def details(self, request: operations.GetDetailsCrmCallRequest) -> operations.GetDetailsCrmCallResponse:
        r"""Get Call Details
        Get details about all Calls. 
        Details include the type, possible values, and other meta data about the fields.
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/call/details'
        headers = {}
        query_params = utils.get_query_params(operations.GetDetailsCrmCallRequest, request)
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('GET', url, params=query_params, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.GetDetailsCrmCallResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.GetDetailsCrmCallResponseBody])
                res.response_body = out

        return res

    
    def find(self, request: operations.GetOneCrmCallRequest) -> operations.GetOneCrmCallResponse:
        r"""Get Call
        Retrieve a single Call by Id
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/call'
        headers = {}
        query_params = utils.get_query_params(operations.GetOneCrmCallRequest, request)
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('GET', url, params=query_params, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.GetOneCrmCallResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.GetOneCrmCallResponseBody])
                res.response_body = out

        return res

    
    def list(self, request: operations.GetAllCrmCallsRequest) -> operations.GetAllCrmCallsResponse:
        r"""Get All Calls
        Retrieve all Calls
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/calls'
        headers = {}
        query_params = utils.get_query_params(operations.GetAllCrmCallsRequest, request)
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('GET', url, params=query_params, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.GetAllCrmCallsResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.GetAllCrmCallsResponseBody])
                res.response_body = out

        return res

    
    def search(self, request: operations.SearchCrmCallsRequest) -> operations.SearchCrmCallsResponse:
        r"""Search Calls
        Search all Calls using filters
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/calls/search'
        headers = {}
        req_content_type, data, form = utils.serialize_request_body(request, "request_body", 'json')
        if req_content_type not in ('multipart/form-data', 'multipart/mixed'):
            headers['content-type'] = req_content_type
        query_params = utils.get_query_params(operations.SearchCrmCallsRequest, request)
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('POST', url, params=query_params, data=data, files=form, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.SearchCrmCallsResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.SearchCrmCallsResponseBody])
                res.response_body = out

        return res

    
    def update(self, request: operations.PutCrmCallRequestBody) -> operations.PutCrmCallResponse:
        r"""Update Call
        Update an Call by Id.
        """
        base_url = self._server_url
        
        url = base_url.removesuffix('/') + '/crm/call'
        headers = {}
        req_content_type, data, form = utils.serialize_request_body(request, "request", 'json')
        if req_content_type not in ('multipart/form-data', 'multipart/mixed'):
            headers['content-type'] = req_content_type
        headers['Accept'] = 'application/json'
        headers['user-agent'] = f'speakeasy-sdk/{self._language} {self._sdk_version} {self._gen_version}'
        
        client = self._security_client
        
        http_res = client.request('PATCH', url, data=data, files=form, headers=headers)
        content_type = http_res.headers.get('Content-Type')

        res = operations.PutCrmCallResponse(status_code=http_res.status_code, content_type=content_type, raw_response=http_res)
        
        if http_res.status_code == 200:
            if utils.match_content_type(content_type, 'application/json'):
                out = utils.unmarshal_json(http_res.text, Optional[operations.PutCrmCallResponseBody])
                res.response_body = out

        return res

    